import lxml.etree as et
import csv
import logging

keys= ['Variant group', 
       'product ID',
       'ean',
       'category',
       'title',
       'short description',
       'long description',
       'brand',
       'web price',
       'VAT',
       'weight',
       'width',
       'lenght',
       'height',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media']
       
def readOldCSV(input_file, new_name):
    root = []
    variant_counter = 0
    for event, elem in et.iterparse(input_file):
        if elem.tag == "o":
            entry = {
                'Variant group': '', 
                'product ID': '', 
                'ean': '', 
                'category': '', 
                'title': '', 
                'short description': '', 
                'long description': '', 
                'brand': '', 
                'web price': '', 
                'VAT': '', 
                'weight': '', 
                'width': '', 
                'lenght': '', 
                'height': '', 
                'media1': '', 
                'media2': '', 
                'media3': '', 
                'media4': '', 
                'media5': '', 
                'media6': '', 
                'media7': '', 
                'media8': '', 
                'media9': '', 
                'media10': '', 
                'media11': '', 
                'media12': '', 
                'media13': '', 
                'media14': '', 
            }
            
            entry['Variant group'] = variant_counter
            variant_counter += 1
            if elem.find('cat') is not None:
                entry['category'] = elem.find('cat').text
            if elem.find('name') is not None:
                entry['title'] = elem.find('name').text
            if elem.find('desc') is not None:
                entry['long description'] = elem.find('desc').text
            if 'id' in elem.attrib:
                entry['product ID'] = elem.attrib['id']
            if 'price' in elem.attrib:
                entry['web price'] = elem.attrib['price']
            if 'weight' in elem.attrib:
                entry['weight'] = elem.attrib['weight']
            
            if elem.find('attrs').findall('a'):
                for attribute in elem.find('attrs').findall('a'):
                    if attribute.attrib['name'] == 'EAN':
                        entry['ean'] = attribute.text
                    if attribute.attrib['name'] == 'Szerokość':
                        entry['width'] = attribute.text
                    if attribute.attrib['name'] == 'Wysokość':
                        entry['height'] = attribute.text
                    if attribute.attrib['name'] == 'Długość':
                        entry['lenght'] = attribute.text
            
            if elem.find('imgs').findall('main'):
                entry['media1'] = elem.find('imgs').findall('main')[0].attrib['url']
            
            counter = 2
            if elem.find('imgs').findall('i'):
                for img in elem.find('imgs').findall('i'):
                    entry['media' + str(counter)] = img.attrib['url']
                    counter +=1
                    if counter == 13:
                        break
            
            entry_to_save = []
            counter = 0 
            for x in entry:
                entry_to_save.append(entry[x])
                counter += 1
            elem.clear()
            root.append(entry_to_save)
            logging.info('Successfully appended entry ' + str(entry['product ID']))
    save_to_csv(root, new_name)
        

def save_to_csv(root, new_name):
    with open(new_name, 'w', newline='', encoding='utf-8') as output_file:
        counter1 = 0
        for x in keys:
            if counter1 == len(keys)-1:
                output_file.write(x+'\n')
            else:
                output_file.write(x+';')
            counter1 += 1
        
        dict_writer = csv.writer(output_file, delimiter=';')
        dict_writer.writerows(root)

def execute(old_name, new_name):
    readOldCSV(old_name, new_name)